<?php

/* --------------------------------------------------------------------------*/
/*                                                                           */
/* QuickTime Audio/Video Posting WordPress Plugin							 */   
/* Written by Shawn Van Every <vanevery@walking-productions.com> 			 */
/* and John Schimmel														 */
/*                                                                           */
/* Copyright (c) 2007 Shawn Van Every <vanevery@walking-productions.com>	 */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License               */
/* as published by the Free Software Foundation; either version 2            */
/* of the License, or (at your option) any later version.                    */
/*                                                                           */
/* See file LICENSE for further informations on licensing terms.             */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software Foundation,   */
/* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           */
/*                                                                           */
/* --------------------------------------------------------------------------*/

/*
Plugin Name: QuickTime Audio/Video Posting WPP
Plugin URI: 
Description: Easily Embed Audio/Video in WordPress
Author: Shawn Van Every and John Schimmel
Version: 1.2.2A
Author URI: http://www.walking-productions.com/shawn.html
*/ 

class qtAudioVideoPosting
{
	/* Some variables */
	var $posts_table_name;
	var $manage_entry_path;
	//var $mime_types;
	var $qtAudioVideoPostingVersion;
		
	function __construct()
	{
		$this->qtAudioVideoPosting();
	}
	
	function qtAudioVideoPosting()
	{
		global $wpdb;
		
		$this->qtAudioVideoPostingVersion = "1.2.2";

		
		add_filter('the_content', array(&$this,'displayVideoPost'));
		add_filter('the_excerpt', array(&$this,'displayVideoPost'));
		add_filter('wp_head', array(&$this,'display_js'));
		add_action('save_post',array(&$this,'save_form'));
		add_action('delete_post',array(&$this,'deleteVideoPost'));
		add_filter('edit_form_advanced',array(&$this,'form'));
		add_filter('simple_form',array(&$this,'form'));
		add_action('activate_qtAudioVideoPosting/qtAudioVideoPosting.php',array(&$this,'install'));		
		add_filter('upload_mimes',array(&$this,'video_mime_types'));

		$this->posts_table_name = $wpdb->prefix . "qtAudioVideoPosting_posts";
		$this->manage_entry_path = get_settings('siteurl')."/wp-content/plugins/qtAudioVideoPosting"; 
		/*
		$new_mime_types = array(
			'flv' => 'video/x-flv',
			'3gp' => 'video/3gpp',		
			'3g2' => 'video/3gpp2',
			'mp4' => 'video/mpeg',
			'wav' => 'audio/wav',
            'asf' => 'video/asf',
            'asx' => 'video/asf',
            'wax' => 'video/asf',
            'wmv' => 'video/asf',
            'wmx' => 'video/asf',
            'avi' => 'video/avi',
            'mov' => 'video/quicktime',
            'qt'  => 'video/quicktime',
            'mpeg'=> 'video/mpeg',
            'mpg' => 'video/mpeg',
            'mpe' => 'video/mpeg'
		);
		$this->mime_types = $new_mime_types;
		*/
	}

	/* Plugin install */
	function install() 
	{
	   global $wpdb;

	   $installed_ver = get_option("qtAudioVideoPostingVersion");
	  
	   if ($installed_ver != $this->qtAudioVideoPostingVersion)
	   {
		  $sql = "CREATE TABLE ".$this->posts_table_name." (
		  	  id bigint(20) not null auto_increment, 
			  post_id bigint(20) not null,
			  video_url text null,
			  video_width int(10) null,
			  video_height int(10) null,
			  video_text text null,
			  video_image text null,
			  video_display text null,
			  video_loop int(1) not null default 0,
			  UNIQUE KEY id (id)
			);";
	
		if ($wp_version >= '2.3') { 
			require_once(ABSPATH.'wp-admin/includes/upgrade.php'); 
		} else { 
			require_once(ABSPATH.'wp-admin/upgrade-functions.php') ; 
		}
		  //maybe_add_column($this->posts_table_name, 'video_loop', "alter table $this->posts_table_name add video_loop int(1) not null default 0;");
		  
		  dbDelta($sql);
		  update_option("qtAudioVideoPostingVersion", $this->qtAudioVideoPostingVersion);
	   }
	}	

	/* Display Portions */
	function displayVideoPost($the_content) 
	{
		global $wpdb,$post;
		$videoData = $this->getVideoPost($post->ID);
		
		$video_loop = "FALSE";
		if ($videoData->video_loop == 1)
		{
			$video_loop = "TRUE";
		}
		
    	if ($videoData->video_url) 
    	{    		
		if (!empty($videoData->video_image))
		{
			$new_content = $this->generate_tags($post->ID,$videoData->video_url,$videoData->video_width,$videoData->video_height,$videoData->video_text,$videoData->video_image,$video_loop);
		}
		else
		{
			$new_content = $this->generate_tags($post->ID,$videoData->video_url,$videoData->video_width,$videoData->video_height,$videoData->video_text,"",$video_loop);				
		}
			
    		if ($videoData->video_display == "top") 
    		{
    			$new_content = $new_content . $the_content;
    		} 
    		else 
    		{
    			$new_content = $the_content . $new_content;
    		}
    		
    		return $new_content;
    	} 
    	else 
    	{ 
    		return $the_content; 
    	}
	}	

	function display_js()
	{
	?>
		<script language="JavaScript" src="<?php echo $this->manage_entry_path; ?>/qtobject.js"></script>	

		<script type="text/javascript">
		<!--		
			function doQTObject(divid,url,width,height,autoplay,loop)
			{
				var myQTObject = new QTObject(url, "movieplayer", width, height);
				myQTObject.altTxt = "This requires QuickTime: http://www.apple.com/quicktime/";
				myQTObject.addParam("controller", "true");
				myQTObject.addParam("AUTOPLAY",autoplay);
				myQTObject.addParam("SCALE","ASPECT");
				myQTObject.addParam("LOOP",loop);
				myQTObject.write(divid);
				return false;
			}
		// -->	
		</script>
		
	<?php
	}

	function generate_tags($post_id,$movie,$width,$height,$text,$image,$loop)
	{
		$tags = "";
		$tags .= "
			<br>
			<div id=\"videoPost_display_" . $post_id . "\">
				<script type=\"text/javascript\">
				<!--
					";
					if ($image != "")
					{
						$tags .= "document.write('<a href=\"" . $movie . "\" onClick=\"doQTObject(\\'videoPost_display_" . $post_id . "\\',\\'" . $movie . "\\',\\'$width\\',\\'" . $height . "\\',true,\\'$loop\\'); return false;\"><img src=\"" . $image . "\" border=\"0\"><br>".$text."</a>');";
					}
					else
					{
						$tags .= "document.write('<a href=\"" . $movie . "\" onClick=\"doQTObject(\\'videoPost_display_" . $post_id . "\\',\\'" . $movie . "\\',\\'" . $width . "\\',\\'" . $height . "\\',true,\\'$loop\\'); return false;\">".$text."</a>');";
					}
		$tags .= "			
				// -->	
				</script>
				<noscript>
					<OBJECT CLASSID=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" WIDTH=\"$width\" HEIGHT=\"$height\" CODEBASE=\"http://www.apple.com/qtactivex/qtplugin.cab\">
					<PARAM name=\"SRC\" VALUE=\"$movie\" />
					<PARAM name=\"CONTROLLER\" VALUE=\"true\" />
					<PARAM name=\"AUTOPLAY\" VALUE=\"false\" />
					<PARAM name=\"SCALE\" VALUE=\"ASPECT\" />
					<PARAM name=\"LOOP\" VALUE=\"$loop\" />
					<EMBED SRC=\"$movie\" CONTROLLER=\"true\" WIDTH=\"$width\" HEIGHT=\"$height\" AUTOPLAY=\"false\" SCALE=\"ASPECT\" LOOP=\"$loop\" PLUGINSPAGE=\"http://www.apple.com/quicktime/download/\"></EMBED>
					</OBJECT>
				</noscript>
			</div>	
		";
		return $tags;
	}

	function form($thing) 
	{
		global $post_ID;
	
		if (!empty($post_ID))
		{
			$result = $this->getVideoPost($post_ID);
		}
		else
		{
			$result = "";
		}
		
	?>
		<div id="qtAudioVideoPosting_admin" >
			<h3 class="dbx-handle">QuickTime Audio/Video Posting</h3>
			<div id="qtAudioVideoPosting_body" style="height:300px;background:#F2F3F5;width:100%;float:top;padding:5px;margin-top:3px;margin-right:2px;">
				<div id="videoComment_form_container" style="float:left;width:48%;">
					<b>Add Audio/Video to this post.</b>
					<br>
					<table border="0" width="80%">
						<tr>
							<td nowrap>Audio/Video URL</td>
							<td>
							<input type="textbox" id="qtAudioVideoPosting_form_video_url" name="qtAudioVideoPosting_form_video_url" style="width:100%;" <?php if (!empty($result->video_url)) { echo " value=\"$result->video_url\"";}?>>
							</td>
						</tr>
						<tr>
							<td><!--empty cell under video--></td>
							<td>
								<table>
									<tr>
										<td width="50%">Width <input type="textbox" id="qtAudioVideoPosting_form_video_width" name="qtAudioVideoPosting_form_video_width" size="4"<?php if (!empty($result->video_width)) { echo " value=\"$result->video_width\"";}?>></td>
										
										<td width="50%">Height <input type="textbox" id="qtAudioVideoPosting_form_video_height" name="qtAudioVideoPosting_form_video_height" size="4"<?php if (!empty($result->video_height)) { echo " value=\"$result->video_height\"";}?>></td>
										
									</tr>
								</table>
							</td>				
						</tr>
					</table>
					<div style="border-bottom:1px dotted grey; width:95%;height:10px;margin-bottom:10px;"></div>
					<b>Blog Display Options</b> <small>(define appearance in blog post)</small><br>
					<div id="qtAudioVideoPosting_form_display_container">
						Text link: <input type="textbox" id="qtAudioVideoPosting_form_display_text" name="qtAudioVideoPosting_form_display_text" value="<?php if (!empty($result->video_text)) { echo $result->video_text; } else { echo "Click to Watch"; }?>" onFocus="this.select()"><br />
						Optional Image URL : <input type="textbox" id="qtAudioVideoPosting_form_display_image" name="qtAudioVideoPosting_form_display_image"<?php if (!empty($result->video_image)) { echo " value=\"$result->video_image\"";}?>><br />
						<br />
						Place in entry at
						<select id="qtAudioVideoPosting_form_display_position" name="qtAudioVideoPosting_form_display_position">
							<option value="top" <?php if (!empty($result->video_display) && $result->video_display == "top") { echo " selected";}?>>Top</option>
							<option value="bottom" <?php if (!empty($result->video_display) && $result->video_display == "bottom") { echo " selected";}?>>Bottom</option>
						</select>
						<br />
						Loop Video
						<select id="qtAudioVideoPosting_form_video_loop" name="qtAudioVideoPosting_form_video_loop">
							<option value="0" <?php if (!empty($result->video_loop) && $result->video_loop == 0) { echo " selected";}?>>No</option>						
							<option value="1" <?php if (!empty($result->video_loop) && $result->video_loop == 1) { echo " selected";}?>>Yes</option>
						</select>
					</div>
				</div>			
			</div>
			<div style="float:top;" id="qtAudioVideoPosting_footer"></div>
		</div>	
	<?php
	}

	/* Admin Form Action */
	function save_form($postid) 
	{		
		global $wpdb;

		//if the video url, width and height are provided save the entry
		if (isset($_POST['qtAudioVideoPosting_form_video_url']) && isset($_POST['qtAudioVideoPosting_form_video_width']) && isset($_POST['qtAudioVideoPosting_form_video_height']) && ($_POST['qtAudioVideoPosting_form_video_url'] != "") && ($_POST['qtAudioVideoPosting_form_video_width'] != "") && ($_POST['qtAudioVideoPosting_form_video_height'] != "") && ($_POST['qtAudioVideoPosting_form_video_loop'] != "")
		
		) 
		{			
			$success = $this->insertVideoPost($postid, $_POST['qtAudioVideoPosting_form_video_url'], $_POST['qtAudioVideoPosting_form_video_width'], $_POST['qtAudioVideoPosting_form_video_height'], $_POST['qtAudioVideoPosting_form_display_text'], $_POST['qtAudioVideoPosting_form_display_image'],  $_POST['qtAudioVideoPosting_form_display_position'],  $_POST['qtAudioVideoPosting_form_video_loop']);
	
			if ($headers = wp_get_http_headers($_POST['qtAudioVideoPosting_form_video_url'])) 
			{
				$len = (int) $headers['content-length'];
				$type = $wpdb->escape($headers['content-type']);
				$allowed_types = array('video', 'audio');
				
				if (in_array( substr( $type, 0, strpos( $type, "/" ) ), $allowed_types )) 
				{
					$meta_value = $_POST['qtAudioVideoPosting_form_video_url'] . "\n$len\n$type\n";
					/*
						These are the functions that should be used but they aren't working right
						add_post_meta
						delete_post_meta
						get_post_meta
						update_post_meta
					*/
					
					$existing_enclosures = get_post_meta($postid, 'enclosure', false);
					if (empty($existing_enclosures))
					{
						add_post_meta($postid,'enclosure',$meta_value);
					}
					else
					{
						update_post_meta($postid,'enclosure',$meta_value);
					}
					// The above will only allow one enclosure per post..  Probably ok..
				}
			}
		}
	}

	/* Database Functions */
	function getVideoPost($postid)
	{
		global $wpdb;
	
		$vc = $wpdb->get_row("select post_id, video_url, video_width, video_height, video_text, video_image, video_display, video_loop from $this->posts_table_name where post_id = $postid");
		return $vc;
	}
	
	//delete_post hook
	function deleteVideoPost($postid)
	{
		global $wpdb;
		$success = $wpdb->query("delete from $this->posts_table_name where post_id = $postid");
		return $success;
	}
	
	function insertVideoPost($postid, $video_url, $video_width, $video_height, $video_text, $video_image, $video_display, $video_loop)
	{
		global $wpdb;

		$video_url = $wpdb->escape($video_url);
		$video_width = $wpdb->escape($video_width);
		$video_height = $wpdb->escape($video_height);
		$video_text = $wpdb->escape($video_text);
		$video_image = $wpdb->escape($video_image);
		$video_display = $wpdb->escape($video_display);
		$video_loop = $wpdb->escape($video_loop);
		$existing_postid = $wpdb->get_var("select post_id from $this->posts_table_name where post_id = $postid");

		//echo $this->posts_table_name;
		//$something = $wpdb->get_results("show tables");
		//print_r($something);

		$success = FALSE;
		if (!empty($existing_postid) && $existing_postid == $postid)
		{
			$success = $wpdb->query("
				UPDATE $this->posts_table_name
				SET video_url = '$video_url',
					video_width = '$video_width',
					video_height = '$video_height',
					video_text = '$video_text',
					video_image = '$video_image',
					video_display = '$video_display',
					video_loop = $video_loop
				WHERE post_id = $postid");			
		}
		else
		{
			$success = $wpdb->query("
				INSERT INTO $this->posts_table_name				(post_id,video_url,video_width,video_height,video_text,video_image,video_display,video_loop)
				VALUES ($postid,'$video_url', '$video_width', '$video_height', '$video_text', '$video_image', '$video_display', $video_loop)");			
		}
			
		return $success;
	}
	
	/* This is to allow wordpress to accept other file types */
	/* For existing list, see wp_check_filetype() in functions.php */
	function video_mime_types($existing_types)
	{
		$new_types = array(
			'ac3' => 'audio/ac3',
			'mpa' => 'audio/MPA',
			'3gp' => 'video/3gpp',		
			'3g2' => 'video/3gpp2'			
		);
		return array_merge($existing_types,$new_types);
	}
}

$qtAudioVideoPosting = new qtAudioVideoPosting;
?>
